from os.path import join
from ament_index_python.packages import get_package_share_directory
from launch_ros.actions import LoadComposableNodes
from launch_ros.descriptions import ComposableNode
from launch import LaunchDescription

def generate_launch_description():
  pkg_prefix = get_package_share_directory('practice_scamper')
  components = LoadComposableNodes(
    target_container='scamper_container',
    composable_node_descriptions=[
      ComposableNode(
        package='practice_scamper',
        plugin='practice_scamper::ColorExtractor',
        name='color_extractor',
        parameters=[
          join(pkg_prefix, 'cfg/color_extractor.yaml')
        ],
        extra_arguments=[
          {'use_intra_process_comms': True}
        ]
      ),
      ComposableNode(
        package='practice_scamper',
        plugin='practice_scamper::ColorExtractorViewer',
        name='color_extractor_viewer',
        extra_arguments=[
          {'use_intra_process_comms': True}
        ]
      )
    ]
  )
  return LaunchDescription([
    components
  ])