#include <rclcpp/rclcpp.hpp>
#include <thread>

int main(int argc, char **argv)
{
  /*** プロセスの初期化 ***/
  rclcpp::init(argc, argv);
  /*** ノードの初期化 ***/
  auto node = rclcpp::Node::make_shared("parameter");
  /*** パラメータの宣言 ***/
  int int_val = node->declare_parameter<int>("int_val", 0);
  double double_val = node->declare_parameter<double>("double_val", 1.0);
  std::string str_val = node->declare_parameter<std::string>("str_val", "hello");
  /*** spin関数を別スレッドで実行 ***/
  std::thread([&]{rclcpp::spin(node);}).detach();
  /*** ループ周期の設定 ***/
  rclcpp::WallRate loop(1);
  while(rclcpp::ok()){
    node->get_parameter("int_val", int_val);
    node->get_parameter("double_val", double_val);
    node->get_parameter("std_val", str_val);
    RCLCPP_INFO(node->get_logger(), "int : %d, double : %lf, str : %s", 
                int_val, double_val, str_val.c_str());
    loop.sleep();
  }
  /*** プロセスの終了 ***/
  rclcpp::shutdown();
  return 0;
}