#include <rclcpp/rclcpp.hpp>
#include <std_srvs/srv/empty.hpp>

/*** 名前空間を省略して利用できるように宣言 ***/
using namespace std_srvs::srv;
/*** グローバル変数の宣言 ***/
rclcpp::Node::SharedPtr g_node = nullptr;

/*** サービスのコールバック関数 ***/
void serviceSayHello(const std::shared_ptr<rmw_request_id_t> header,
                     const std::shared_ptr<Empty::Request> req,
                     const std::shared_ptr<Empty::Response> res)
{
  RCLCPP_INFO(g_node->get_logger(), "Hello");
}

int main(int argc, char **argv)
{
  /*** プロセスの初期化 ***/
  rclcpp::init(argc, argv);
  /*** ノードの初期化 ***/
  g_node = rclcpp::Node::make_shared("service_server");
  /*** サービス(サーバ)の初期化 ***/
  auto server = g_node->create_service<Empty>("say_hello", serviceSayHello);
  /*** コールバックの発生を待機 ***/
  rclcpp::spin(g_node);
  /*** プロセスの終了 ***/
  g_node = nullptr;
  rclcpp::shutdown();
  return 0;
}